#ifndef FOREGROUND_STUFF_H
#define FOREGROUND_STUFF_H

#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/ml/ml.hpp>

#include "TrainStuff.h"
#include "DatasetStuff.h"
#include "SequenceStuff.h"

cv::Mat trainForegroundLocationPattern(std::string datasetName, const int trainVersion, const float scale);

/* Training foreground classifier */
std::pair<cv::Mat,cv::Mat> trainingDataXiaofengClassifier(std::string datasetName, const int trainVersion, const float scale, const int segType); 
void trainXiaofengClassifier(std::string datasetName, const int trainVersion, CvSVM* trainer, const float scale, const int segType);
void trainXiaofengClassifier_svmlight(std::string datasetName, const int trainVersion, LinearClassifier& trainer, const float scale, const int segType);

cv::Mat fg_getUnary_svmlight(Sequence& sq, LinearClassifier trainer, const int fromFrame, const int toFrame, const cv::Mat& locationPattern);

std::vector<cv::Mat> fgSegmentation(Sequence& sq, CvSVM* trainer, const int fromFrame, const int toFrame, const cv::Mat& locationPattern);

std::vector<cv::Mat> fgSegmentation_svmlight(Sequence& sq, LinearClassifier& trainer, const int fromFrame, const int toFrame, const cv::Mat& locationPattern);

void batch_fgSegmentation(std::string datasetName, const int seqNumber, const int startFrame, const int endFrame, const int trainVersion, const float scale, const int segType);

cv::Mat futureManipulationFeatureVector(Sequence& sq, Dataset& db, const int seqNumber, const int frame, const int trainVersion);

cv::Mat cleanForegroundMask(const cv::Mat& image, const cv::Mat& mask);

#endif //FOREGROUND_STUFF_H

