#ifndef GAZE_STUFF_H
#define GAZE_STUFF_H

#include <opencv2/opencv.hpp>

/* returns a matrix
   the first column is time stamp
   the second column is y
   the third column is x
*/
cv::Mat readGazePoints_SMI(const char * filename, const float scale, const int marginY, const int marginX);

/*
  returns a vector with size equal to the number of frames (in sequence), which contains (y,x) location of gaze points
 */
std::vector<std::pair<float,float> > rawGazePointsToFrameLocations_SMI(const cv::Mat& rawData, const int numFrames, const int fps);

#endif //GAZE_STUFF_H
