#include <utility>
#include <list> 
#include "ImageStuff.h"

using namespace cv;
using namespace std;

/******************************************************************************************************/

void Mat2uchars(uchar *** imageData, Mat inputImage){
  uchar * rawPtr = inputImage.ptr();

  Size wh = inputImage.size();
  int width = wh.width;
  int height = wh.height;
  int ch = inputImage.channels();

  /*imageData = new uchar** [height];
  for(int i = 0; i < height; i++)
    imageData[i] = new uchar* [width];
  for(int i = 0; i < height; i++)
    for(int j = 0; j < width; j++)
      imageData[i][j] = new uchar[ch];
  */

  int count = 0;
  for(int i = 0; i < height; i++){
    for(int j = 0; j < width; j++){
      for(int k = ch-1; k >= 0; k--){
	imageData[i][j][k] = rawPtr[count++];
      }
    }
  }

}

/******************************************************************************************************/

void uchars2Mat(Mat& inputImage, uchar *** imageData){
  // The answer is RGB and not BGR
  Size wh = inputImage.size();
  int width = wh.width;
  int height = wh.height;
  int ch = inputImage.channels();
  uchar * rawPtr = inputImage.ptr();

  int count = 0;
  for(int i = 0; i < height; i++){
    for(int j = 0; j < width; j++){
      for(int k = ch-1; k >= 0; k--){
	rawPtr[count++] = imageData[i][j][k];
	//cout << (int)(imageData[i][j][k]) << endl;
      }
    }
  }  

}

/******************************************************************************************************/

void copyUchars(uchar *** answer, uchar *** source, const int height, const int width, const int channels){
  for(int i = 0; i < height; i++){
    for(int j = 0; j < width; j++){
      for(int k = 0; k < channels; k++){
	answer[i][j][k] = source[i][j][k];
      }
    }
  }  
}
/******************************************************************************************************/

void drawRectangle(Mat& inputImage, const int y, const int x, const int height, const int width, const Scalar color, const int thickness){
  int scaler = 2;
  int x1 = (x-width)*scaler;
  int x2 = (x+width)*scaler;
  int y1 = (y-height)*scaler;
  int y2 = (y+height)*scaler;
  Point p1(x1, y2);
  Point p2(x2, y1);

  rectangle(inputImage, p1, p2, color, thickness, 8, 1);
}

/******************************************************************************************************/

cv::Mat myImagesc(const cv::Mat& inputMatrix){
  int maxY, maxX;
  int maxValue = matrixMaxValue<int>(inputMatrix, maxY, maxX);
  //cout << "Max Value: " << maxValue << endl;
  double step = 255.0/(double)(maxValue);

  Size wh = inputMatrix.size();
  int height = wh.height;
  int width = wh.width;
  
  Mat answer(height, width, CV_8UC3);

  typedef Vec<uchar,3> Vec3u;

  for(int i = 0; i < height; i++){
    for(int j = 0; j < width; j++){
      double temp = (double)(inputMatrix.at<int>(i,j));
      answer.at<Vec3u>(i,j)[0] = 255-(uchar)(floor(temp*step));
      answer.at<Vec3u>(i,j)[1] = 0;
      answer.at<Vec3u>(i,j)[2] = (uchar)(floor(temp*step));
    }
  }
  return answer;
}

/******************************************************************************************************/
/*void getImage4connectedAdjacencyMatrix(int r, int c, SparseMat & adj_r, SparseMat & adj_l, SparseMat & adj_u, SparseMat & adj_d){
  cout << r << " " << c << endl;
  cout << "fuck" << endl;
  Mat temp = Mat::ones(r-1,1,CV_32F) ;
  //cout << temp << endl;
  Mat temp2 = Mat::zeros(1,1,CV_32F);
  //cout << temp2 << endl;
  cout << "chello" << endl;
  temp.push_back(temp2);
  //cout << temp << endl;
  Mat diagVec1 = repmat(temp, c, 1);
  diagVec1 = diagVec1.rowRange(0, diagVec1.rows-1);
  Mat diagVec2 = Mat::ones(r*(c-1), 1, CV_32F);

  //cout << diagVec1 << endl;
  //cout << diagVec1.rows << " " << diagVec1.cols << endl;

  //SparseMat diagVec1_sparse(diagVec1);
  //SparseMat diagVec2_sparse(diagVec2);

  cout << "chello" << endl;

  Mat Vec1 = Mat::diag(diagVec1);
  Mat Vec2 = Mat::diag(diagVec2);

  //cout << Vec1.rows << " " << Vec1.cols << endl;
  //cout << Vec2.rows << " " << Vec2.cols << endl;

  cout << "fuck1" << endl;

  Mat adj_d_ = Mat::zeros(1, Vec1.rows, CV_32F);
  cout << "fuck2" << endl;
  temp = Vec1.t();
  cout << "fuck3" << endl;
  adj_d_.push_back(temp);
  cout << "fuck4" << endl;
  adj_d_ = adj_d_.t();
  cout << "fuck5" << endl;
  temp = Mat::zeros(1, Vec1.cols+1, CV_32F);
  cout << "fuck6" << endl;
  adj_d_.push_back(temp);
  cout << "fuck7" << endl;

  //cout << adj_d.rows << " " << adj_d.cols << endl;

  Mat adj_u_ = adj_d_.t();

  Mat adj_r_ = Mat::zeros(r, Vec2.rows, CV_32F);
  temp = Vec2.t();
  adj_r_.push_back(temp);
  adj_r_ = adj_r_.t();
  temp = Mat::zeros(r, Vec2.cols+r, CV_32F);
  adj_r_.push_back(temp);

  Mat adj_l_ = adj_r_.t();

  SparseMat adj_d__(adj_d_);
  SparseMat adj_l__(adj_l_);
  SparseMat adj_r__(adj_r_);
  SparseMat adj_u__(adj_u_);
  adj_d__.copyTo(adj_d);
  adj_u__.copyTo(adj_u);
  adj_l__.copyTo(adj_l);
  adj_r__.copyTo(adj_r);

  return;
}
*/

void getImage4connectedAdjacencyMatrix(int r, int c, SparseMat & adj_r, SparseMat & adj_l, SparseMat & adj_u, SparseMat & adj_d){
  int dims = 2;
  int sizes[2];
  sizes[0] = c*r;
  sizes[1] = c*r;
  int type = CV_32F;
  
  SparseMat adj_r_(dims, sizes, type);
  SparseMat adj_l_(dims, sizes, type);
  for(int i = r; i < r*c; i++){
    adj_r_.ref<float>(i-r, i) = 1;
    adj_l_.ref<float>(i, i-r) = 1;
  }
  adj_r_.copyTo(adj_r);
  adj_l_.copyTo(adj_l);
  
  SparseMat adj_d_(dims, sizes, type);
  SparseMat adj_u_(dims, sizes, type);
  for(int i = 1; i < r*c; i++){
    adj_d_.ref<float>(i-1, i) = 1;
    adj_u_.ref<float>(i, i-1) = 1;
  }
  adj_d_.copyTo(adj_d);
  adj_u_.copyTo(adj_u);

  return;
}

/******************************************************************************************************/
Mat bwLabel(const Mat& bw){
  int ysize = bw.rows;
  int xsize = bw.cols;
  Mat labels(ysize, xsize, CV_32S);
  for(int i = 0; i < ysize; i++)
    for(int j = 0; j < xsize; j++)
      labels.at<int>(i,j) = 0;

  int l = 0;
  bool labeled;
  int l_;
  for(int i = 0; i < ysize; i++){
    for(int j = 0; j < xsize; j++){
      if(bw.at<uchar>(i,j) > 0)
	continue;
      labeled = false;
      l_ = INT_MAX;
      if(i > 0)
	if(bw.at<uchar>(i-1,j) == 0){
	  l_ = labels.at<int>(i-1,j);
	  labeled = true;
	}
      if(j > 0)
	if(bw.at<uchar>(i,j-1) == 0){
	  l_ = min(labels.at<int>(i,j-1), l_);
	  labeled = true;
	}
      if(labeled){
	labels.at<int>(i,j) = l_;
      }
      if(!labeled){
	//	cout << l << endl;
	l++;
	labels.at<int>(i,j) = l;
      }
    }
  }

  for(int i = ysize-1; i >= 0; i--){
    for(int j = xsize-1; j >= 0; j--){
      if(bw.at<uchar>(i,j) > 0)
	continue;
      if(i < ysize-1)
	if(bw.at<uchar>(i+1,j) == 0)
	  if(labels.at<int>(i+1,j) < labels.at<int>(i,j))
	    labels.at<int>(i,j) = labels.at<int>(i+1,j);

      if(j < xsize-1)
	if(bw.at<uchar>(i,j+1) == 0)
	  if(labels.at<int>(i,j+1) < labels.at<int>(i,j))
	    labels.at<int>(i,j) = labels.at<int>(i,j+1);
    }
  }

  for(int i = 0; i < ysize; i++){
    for(int j = xsize-1; j >= 0; j--){
      if(bw.at<uchar>(i,j) > 0)
	continue;
      if(i > 0)
	if(bw.at<uchar>(i-1,j) == 0)
	  if(labels.at<int>(i-1,j) < labels.at<int>(i,j))
	    labels.at<int>(i,j) = labels.at<int>(i-1,j);
      if(j < xsize-1)
	if(bw.at<uchar>(i,j+1) == 0)
	  if(labels.at<int>(i,j+1) < labels.at<int>(i,j))
	    labels.at<int>(i,j) = labels.at<int>(i,j+1);
    }
  }

  for(int i = ysize-1; i >= 0; i--){
    for(int j = 0; j < xsize; j++){
      if(bw.at<uchar>(i,j) > 0)
	continue;
      if(i < ysize-1)
	if(bw.at<uchar>(i+1,j) == 0)
	  if(labels.at<int>(i+1,j) < labels.at<int>(i,j))
	    labels.at<int>(i,j) = labels.at<int>(i+1,j);
      if(j > 0)
	if(bw.at<uchar>(i,j-1) == 0)
	  if(labels.at<int>(i,j-1) < labels.at<int>(i,j))
	    labels.at<int>(i,j) = labels.at<int>(i,j-1);
    }
  }

  for(int i = 0; i < ysize; i++){
    for(int j = 0; j < xsize; j++){
      if(bw.at<uchar>(i,j) > 0)
	continue;
      if(i > 0)
	if(bw.at<uchar>(i-1,j) == 0)
	  if(labels.at<int>(i-1,j) < labels.at<int>(i,j))
	    labels.at<int>(i,j) = labels.at<int>(i-1,j);
      if(j > 0)
	if(bw.at<uchar>(i,j-1) == 0)
	  if(labels.at<int>(i,j-1) < labels.at<int>(i,j))
	    labels.at<int>(i,j) = labels.at<int>(i,j-1);
    }
  }


  return labels;
}

/******************************************************************************************************/
/******************************************************************************************************/
/******************************************************************************************************/
