#ifndef IMAGE_STUFF_H
#define IMAGE_STUFF_H

#include <opencv2/opencv.hpp>

#include "global.h"

void Mat2uchars(uchar *** answer, cv::Mat source);

void uchars2Mat(cv::Mat& answer, uchar *** source);

void copyUchars(uchar *** answer, uchar *** source, const int height, const int width, const int channels);

void drawRectangle(cv::Mat& inputImage, const int y, const int x, const int height, const int width, cv::Scalar color, const int thickness);

cv::Mat myImagesc(const cv::Mat& inputMatrix);

/* get adjacency matrices of connected pixels to right, left, above, below */
void getImage4connectedAdjacencyMatrix(int r, int c, cv::SparseMat & adj_r, cv::SparseMat & adj_l, cv::SparseMat & adj_u, cv::SparseMat & adj_d);

cv::Mat bwLabel(const cv::Mat& bw);


#endif
