#ifndef INPUTOUTPUTFILE_H
#define INPUTOUTPUTFILE_H

#include <stdio.h>
#include <stdlib.h>

#include "global.h"

bool fileExists(const char * filename);

void writeMatrixToFile(const char * filename, const cv::Mat & matrix);

cv::Mat readMatrixFromFile(const char * filename);

char * getBSDS500TrainImageName(int index);

void writeMaskAsImage(const char * filename, const cv::Mat & mask);

cv::Mat readMaskFromImage(const char * filename);

std::string getImagePath(const char * dataDir, const char * seqName, const char * imType, const int frameNumber);

std::string getContourPath(const char * dataDir, const char * seqName, const int frameNumber);

void write_svm_light_input(const cv::Mat& data, const cv::Mat& labels, const char * filename);

#endif

