#ifndef OBJECT_STUFF_H
#define OBJECT_STUFF_H

#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/ml/ml.hpp>

#include "TrainStuff.h"
#include "DatasetStuff.h"
#include "SequenceStuff.h"


/*************** Training hierarchical object classifiers ******************/
std::pair<cv::Mat,cv::Mat> trainingDataHierarchicalObjectClassifier(std::string datasetName, std::string objectName, const int trainVersion, const int numBins_lab, const int numBins_hog, const int k, const int k2, const int k3); 

void trainHierarchicalObjectClassifier(std::string datasetName, std::string objectName, const int trainVersion, CvSVM * trainer, const int numBins_lab, const int numBins_hog, const int k, const int k2, const int k3, const int kernelType);

void trainHierarchicalObjectClassifier_linear(std::string datasetName, std::string objectName, const int trainVersion, LinearClassifier& trainer, const int numBins_lab, const int numBins_hog, const int k, const int k2, const int k3);

void trainHierarchicalObjectClassifier_svmlight(std::string datasetName, std::string objectName, const int trainVersion, LinearClassifier& trainer, const int numBins_lab, const int numBins_hog, const int k, const int k2, const int k3);

cv::Mat hierarchicalObjectClassification(PriorH& ph, CvSVM * trainer, const cv::Mat& clusterCenters_lab, const cv::Mat& clusterCenters_hog);

cv::Mat hierarchicalObjectClassification(PriorH& ph, const LinearClassifier& trainer, const cv::Mat& clusterCenters_lab, const cv::Mat& clusterCenters_hog);

cv::Mat hierarchicalObjectClassification(PriorH& ph, std::list<CvSVM *>& trainers, const cv::Mat& clusterCenters_lab, const cv::Mat& clusterCenters_hog);

cv::Mat hierarchicalObjectClassification(PriorH& ph, std::vector<LinearClassifier>& trainers, const cv::Mat& clusterCenters_lab, const cv::Mat& clusterCenters_hog);


/*
  return labels range from 0 to the number of object classes (n)
  0-(n-1) correspond to objects
  n corresponds to the unknown class
 */
cv::Mat classificationToLabels(const cv::Mat& classificationMatrix);

#endif //OBJECT_STUFF_H
