#ifndef PAIRWISE_STUFF_H
#define PAIRWISE_STUFF_H

#include "PriorStuff.h"

#include "map"

#include <opencv2/opencv.hpp>

class Pairwise{

 public:
  Pairwise(){}
  Pairwise(const int frame1, const int frame2);
  cv::Mat getImage1(std::map<int, Prior>& priors) const;
  cv::Mat getImage2(std::map<int, Prior>& priors) const;
  cv::Mat getSegmentation1(std::map<int, Prior>& priors) const;
  cv::Mat getSegmentation2(std::map<int, Prior>& priors) const;

  void setFlow(std::map<int, Prior>& priors, double resizeFactor);
  cv::Mat getVX(std::map<int, Prior>& priors);
  cv::Mat getVY(std::map<int, Prior>& priors);
  std::pair<cv::Mat, cv::Mat> getFlow(std::map<int, Prior>& priors);
  cv::SparseMat getTransitionFlow_unnormalized(std::map<int, Prior>& priors);
  cv::SparseMat getTransitionFlow_normalized(std::map<int, Prior>& priors);
  cv::Mat transferFrom1to2(const cv::Mat& prior1, std::map<int, Prior>& priors);
  cv::SparseMat computeTemporal(std::map<int, Prior>& priors);

 private:
  int f1_;
  int f2_;

  bool computed_flow_;
  bool computed_flow_unnormalized_;
  bool computed_flow_normalized_;
  
  std::pair<cv::Mat, cv::Mat> flow_;
  cv::SparseMat transitionFlow_unnormalized_;
  cv::SparseMat transitionFlow_normalized_;
};

#endif //PAIRWISE_STUFF_H
