#ifndef TRAIN_STUFF_H
#define TRAIN_STUFF_H

#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/ml/ml.hpp>

#include "DatasetStuff.h"
#include "SequenceStuff.h"

struct LinearClassifier{
  cv::Mat w;
  float b;
  void save(const char * filename);
  void load(const char * filename);
  void print();
};

/* returns cluster centers of HOG features */
cv::Mat getHOGClusters(std::string datasetName, const int trainVersion, const int clusterNum);

/* returns cluster centers of Lab features */
cv::Mat getLabClusters(std::string datasetName, const int trainVersion, const int clusterNum);

/* 
   returns the weight vector and b for linear classifier
   sets the weightVector and returns the b
*/
LinearClassifier getWeightVectorLinearSVM(CvSVM * trainer);

LinearClassifier svm_light_train(const cv::Mat& data, const cv::Mat& labels, const char * tempFile, const char * modelFile, const char * params);

LinearClassifier svm_light_read_model(const char * modelFile);

cv::Mat classificationToConfusionMatrix(const cv::Mat& classifications, const cv::Mat& labels);

#endif //TRAIN_STUFF_H
