###########################################################################
# IETL library
#
# config/include.mk.in
#
# $Id: include.mk.in,v 1.1 2003/09/01 10:17:43 troyer Exp $
#
# Copyright (C) 1994-2003 by Matthias Troyer <troyer@comp-phys.org>,
#                            Synge Todo <wistaria@comp-phys.org>,
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
###########################################################################

# shell

SHELL = /bin/bash

# path

prefix = /home/alireza/ietl
exec_prefix = /home/alireza/ietl
bindir = /home/alireza/ietl/bin
datadir = /home/alireza/ietl/share
libdir = /home/alireza/ietl/lib
includedir = /home/alireza/ietl/include

# Makefiles

INCLUDE_MK = $(datadir)/ietl/include.mk
RULES_MK = $(datadir)/ietl/rules.mk
RULES_LIB_MK = $(datadir)/ietl/rules-lib.mk

# installer

INSTALL = /usr/bin/install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_SCRIPT = ${INSTALL}
INSTALL_DATA = ${INSTALL} -m 644
INSTALL_LIB = $(INSTALL_DATA)
INSTALL_HEADER = $(INSTALL_DATA)
install_sh = $(bindir)/install-sh
mkinstalldirs = $(SHELL) $(bindir)/mkinstalldirs

# tools

AR = ar cru
ARXX = /home/alireza/ietl/bin/arxx
LN_S = ln -s
MAKEDEPEND = makedepend
MAKEDEPEND_PL = perl $(bindir)/makedepend.pl
RANLIB = ranlib

# for Boost and base

BASE_CPPFLAGS = -DNDEBUG -I  
BASE_LDFLAGS =   
BASE_LIBS = -llapack -lf77blas -latlas   -lm  

# C/C++ compiler

COMPILER = gnu

CC = gcc
CFLAGS = -pthread -w -O3

CXX = g++
CXXFLAGS = -pthread -w -ftemplate-depth-90 -O3 -fexceptions 

CPP = gcc -E
CXXCPP = g++ -E

CPPFLAGS = $(BASE_CPPFLAGS) -I$(includedir)
LDFLAGS = $(BASE_LDFLAGS) -L$(libdir)
LIBS = $(BASE_LIBS)
