#include "FeatureStuff.h"
#include "ImageStuff.h"
#include "SegmentationStuff.h"
#include "Visualizations.h"


using namespace std;
using namespace cv;

int main(int argc, char **argv) {

  if (argc != 3) {
    cout << "usage: " << argv[0] << " image binSize" << endl;
    return 1;
  }

  string imname(argv[1]);
  Mat inputImage = imread(imname);
  int binSize = atoi(argv[2]);

  Mat fv = getHOG(inputImage);

  imshow("inputImage", inputImage);

  Mat colorHist = getColorHistogram(inputImage, binSize);
  
  Mat colorImage = myImagesc(colorHist);
  cout << colorImage.rows << " " << colorImage.cols << endl;
  imshow("Imagesc", colorImage);  

  float sigma = 0.4;
  float k = 100;
  int min_size = 100;
  int num_ccs;
  Mat segmentation = felzenszwalb_segment(inputImage, sigma, k, min_size, &num_ccs);
  sortSegmentNumbers(segmentation);

  //showSegmentationRandom(segmentation, "Felzenszwalb");  

  vector< vector<float> > featureVectors = getFeatureVectors_colorHist(inputImage, binSize, segmentation);
  /*vector<float> temp = featureVectors[0];
  for(int i = 0; i < temp.size(); i++)
    cout << temp[i] << " ";
    cout << endl;*/


  SparseMat adjacencyMatrix = getWeightedAdjacencyMatrix(segmentation);

  SparseMat spatialMatrix = getSpatial_colorHist(featureVectors, adjacencyMatrix, 1, 1);

  /*  int height = inputImage.rows;
  int width = inputImage.cols;
  typedef Vec<uchar,3> Vec3u;
  for(int i = 0; i < height; i++){
    for(int j = 0; j< width; j++){
      cout << (int)(inputImage.at<Vec3u>(i,j)[0]) << endl;
      cout << (int)(inputImage.at<Vec3u>(i,j)[1]) << endl;
      cout << (int)(inputImage.at<Vec3u>(i,j)[2]) << endl;
    }
    }*/

  //showSpatialOnContours(inputImage, segmentation, spatialMatrix);

  cout << "hello" << endl;

  int r = 200;
  int c = 400;
  SparseMat adj_r, adj_l, adj_u, adj_d;
  getImage4connectedAdjacencyMatrix(r, c, adj_r, adj_l, adj_u, adj_d);
  cout << adj_r.size()[0] << " " << adj_r.size()[1] << endl;
  /*  Mat adj_r_full;
  Mat adj_l_full;
  Mat adj_d_full;
  Mat adj_u_full;
  adj_r.copyTo(adj_r_full);
  adj_l.copyTo(adj_l_full);
  adj_d.copyTo(adj_d_full);
  adj_u.copyTo(adj_u_full);
  cout << "adj_r" << endl << adj_r_full << endl;
  cout << "adj_l" << endl << adj_l_full << endl;
  cout << "adj_d" << endl << adj_d_full << endl;
  cout << "adj_u" << endl << adj_u_full << endl;*/

  cvWaitKey(0);

  return 0;

}


