#include "TrainStuff.h"
#include "ForegroundStuff.h"

#include "InputOutputFile.h"
#include "SegmentationStuff.h"
#include "Visualizations.h"
#include "MyMATFileInterface.h"

#include <stdio.h>

using namespace std;
using namespace cv;

int main(int argc, char **argv) {
  if (argc != 2) {
    cout << "usage: " << argv[0] << " seqNumber" << endl;
    return 1;
  }

  int trainVersion = 3;
  string datasetName("GTDA_v3");
  int seqNumber = atoi(argv[1]);
  Dataset db = dataset_setup(datasetName);
  DatasetSeq seq = db.getSequence(seqNumber);

  string dataDir = db.getDataDir();
  string seqName = seq.getSeqName();
  string imType = db.getImType();
  /*int endFrame = 9720;
  int startFrame = 9680;
  Sequence sq(dataDir.c_str(), seqName.c_str(), imType.c_str(), startFrame, endFrame, BERKELEY_SEG, 1);
  
  int frame = 9700;
  Mat output = futureManipulationFeatureVector(sq, db, seqNumber, frame, trainVersion);
  */

  vector<Action> freqActions = db.frequentActions(trainVersion, 3, 2);
  for(int i = 0; i < freqActions.size(); i++){
    freqActions[i].print();
    cout << endl;
  }
  
  /*vector<int> seqs = db.getTrainSeqs(trainVersion);
  vector<int> testSeqs = db.getTestSeqs(trainVersion);
  for(int i = 0; i < testSeqs.size(); i++)
    seqs.push_back(testSeqs[i]);
  */
  vector<int> seqs;
  seqs.push_back(seqNumber);

  for(int s = 0; s < seqs.size(); s++){
    int seqNumber = seqs[s];
    vector<Action> actions = db.getSeqFreqActions(seqNumber, freqActions);
    cout << "Number of actions: " << actions.size() << endl;
    for(int a = 0; a < actions.size(); a++){
      actions[a].print();
      cout << endl;
      int startFrame = actions[a].startFrame;
      int endFrame = actions[a].endFrame;
      for(int frame = startFrame; frame <= endFrame; frame++){
	Mat mask = db.readForegroundMask(seqNumber, frame, trainVersion);
	Mat im = db.getIM(seqNumber, frame);
	mask = cleanForegroundMask(im, mask);
	showMaskOnImage2(mask, im, "FG Mask");
	cvWaitKey(10);
      }
    }

  }

  cvWaitKey(0);

  return 0;
}


