#include "DatasetStuff.h"
#include "GazeStuff.h"

#include "SegmentationStuff.h"
#include "Visualizations.h"
#include "MyMATFileInterface.h"

#include <stdio.h>

using namespace std;
using namespace cv;

int main(int argc, char **argv) {
  if (argc != 2) {
    cout << "usage: " << argv[0] << "<seqNumber>" << endl;
    return 1;
  }

  int seqNumber = atoi(argv[1]);

  Dataset db = dataset_setup("GTDA_v3");
  
  int numFrames = db.getSequence(seqNumber).getSeqLength();
  int fps = db.getFps();
  vector<pair<float,float> > gazes = db.getGazeLocations(seqNumber);

  for(int f = 1; f < numFrames; f+=1){
    Mat im = db.getIM(seqNumber, f);
    float y = gazes[f-1].first;
    float x = gazes[f-1].second;
    cout << y << " " << x << endl;
    circle(im, Point(x,y), 100, cvScalar(0, 0, 255), 5);
    /*char buffer[300];
    buffer[0] = 0;
    sprintf(buffer, "Frame %d", f);*/
    imshow("Frame", im);
    cvWaitKey(10);
  }
  cvWaitKey(0);


  return 0;
}

