#include "ImageStuff.h"
#include "Visualizations.h"
#include "MyMATFileInterface.h"
#include "SegmentationStuff.h"
#include "SparseStuff.h"

#include <stdio.h>

using namespace std;
using namespace cv;

int main(int argc, char **argv) {
  if (argc != 5) {
    cout << "usage: " << argv[0] << " dataDir seqName frameNumber k" << endl;
    return 1;
  }

  int frameNumber = atoi(argv[3]);
  int k = atoi(argv[4]);

  char imPath[200];
  imPath[0] = 0;
  sprintf(imPath, "%s/png/%s/%010d.png", argv[1], argv[2], frameNumber);
  cout << imPath << endl;

  char ucmPath[200];
  ucmPath[0] = 0;
  sprintf(ucmPath, "%s/tmp/%s/%010d/%010d_contour.mat", argv[1], argv[2], frameNumber, frameNumber);
  cout << ucmPath << endl;

  Mat im = imread(imPath);
  imshow("Image", im);

  /*Mat ucm = readUCM(ucmPath);

  int ysize = ucm.rows;
  int xsize = ucm.cols;
  Mat ucmK = Mat::zeros(ysize, xsize, CV_8UC1);
  for(int i = 0; i < ysize; i++)
    for(int j = 0; j < xsize; j++)
      if(ucm.at<uchar>(i,j) > k)
	ucmK.at<uchar>(i,j) = ucm.at<uchar>(i,j);

  imshow("UCM", ucmK);

  Mat segmentation = bwLabel(ucmK);
  int m = sortSegmentNumbers(segmentation);
  cout << "m: " << m << endl;
  showSegmentationRandom(segmentation, "labels");*/

  Mat ucm = readUCM(ucmPath);

  Mat segmentation = berkeley_segment(ucm, k);
  showSegmentationRandom(segmentation, "labels");

  Mat ucms = berkeley_ucmResize(ucm);
  imshow("ucms", ucms);

  SparseMat adjacencyWeights;
  SparseMat adjacencyLengths;

  berkeley_weightedAdjacencyMatrix(ucm, segmentation, adjacencyLengths, adjacencyWeights);
  getWeightedAdjacencyMatrix(segmentation);
  showAdjacencyMatrix(im, segmentation, adjacencyWeights);

  printMatrix<float>(adjacencyWeights);

  cvWaitKey(0);

  return 0;
}

