#include "MotionStuff.h"

using namespace std;
using namespace cv;

int main(int argc, char **argv) {

  Mat P(3, 2, CV_32F);
  P.at<float>(0,0) = 1;
  P.at<float>(0,1) = 1;
  P.at<float>(1,0) = 2;
  P.at<float>(1,1) = 1;
  P.at<float>(2,0) = 1;
  P.at<float>(2,1) = 2;

  Mat V(3, 2, CV_32F);
  V.at<float>(0,0) = 0.5;
  V.at<float>(0,1) = 1.0;
  V.at<float>(1,0) = 0.2;
  V.at<float>(1,1) = 0.4;
  V.at<float>(2,0) = 0.3;
  V.at<float>(2,1) = 0.6;  

  Mat A = affineEstimate(P, V);
  cout << "A: " << endl << A << endl;

  /*****/

  Mat p(4, 2, CV_32F);
  p.at<float>(0,0) = 1;
  p.at<float>(0,1) = 1;
  p.at<float>(1,0) = 2;
  p.at<float>(1,1) = 1;
  p.at<float>(2,0) = 1;
  p.at<float>(2,1) = 2;
  p.at<float>(3,0) = 3;
  p.at<float>(3,1) = 2;

  Mat v(4, 2, CV_32F);
  v.at<float>(0,0) = 0.5;
  v.at<float>(0,1) = 1.0;
  v.at<float>(1,0) = 0.22;
  v.at<float>(1,1) = 0.4;
  v.at<float>(2,0) = 0.3;
  v.at<float>(2,1) = 0.7;
  v.at<float>(3,0) = 3.0;
  v.at<float>(3,1) = 1.0;

  vector<int> inliers;
  A = affineMotionRansac(p, v, 0.3, 100, inliers);
  cout << "A: " << endl << A << endl;
  cout << "Inliers: " << endl;
  for(int i = 0; i < inliers.size(); i++)
    cout << inliers[i] << endl;

  return 0;
}

