#include "PriorStuff.h"
#include "MotionStuff.h"
#include "SegmentationStuff.h"
#include "Visualizations.h"

using namespace std;
using namespace cv;

int main(int argc, char **argv) {
  if (argc != 5) {
    cout << "usage: " << argv[0] << " image1 image2 image3  binSize" << endl;
    return 1;
  }

  string imname1(argv[1]);
  Mat iImage1 = imread(imname1);
  Mat inputImage1(iImage1.rows/3, iImage1.cols/3, CV_8UC3);
  resize(iImage1, inputImage1, inputImage1.size(), 0, 0, INTER_LINEAR);

  string imname2(argv[2]);
  Mat iImage2 = imread(imname2);
  Mat inputImage2(iImage2.rows/3, iImage2.cols/3, CV_8UC3);
  resize(iImage2, inputImage2, inputImage2.size(), 0, 0, INTER_LINEAR);

  string imname3(argv[3]);
  Mat iImage3 = imread(imname3);
  Mat inputImage3(iImage3.rows/3, iImage3.cols/3, CV_8UC3);
  resize(iImage3, inputImage3, inputImage3.size(), 0, 0, INTER_LINEAR);

  int binSize = atoi(argv[4]);

  map<int, Prior> priors;
  Prior p1(inputImage1, 1);
  Prior p2(inputImage2, 2);
  Prior p3(inputImage3, 3);

  priors[1] = p1;
  priors[2] = p2;
  priors[3] = p3;

  /*vector<int> adjFrames;
  adjFrames.push_back(1);
  adjFrames.push_back(3);
  cout << 1 << endl;
  Mat prior2 = p2.getPrior_motionChannel(priors, adjFrames);
  showPrior(prior2, p2.getSegmentation(), "Prior2");*/

  imshow("Im1", p1.getImage());
  showSegmentationRandom(p1.getSegmentation(), "Seg1");
  imshow("Im2", p2.getImage());
  showSegmentationRandom(p2.getSegmentation(), "Seg2");
  imshow("Im3", p3.getImage());
  showSegmentationRandom(p3.getSegmentation(), "Seg3");

  cvWaitKey(0);

  return 0;
}

