#include "SequenceStuff.h"

#include "MotionStuff.h"
#include "SegmentationStuff.h"
#include "Visualizations.h"

#include <stdio.h>

using namespace std;
using namespace cv;

int main(int argc, char **argv) {
  if (argc != 6) {
    cout << "usage: " << argv[0] << "dbname seqNumber startFrame endFrame resizeFactor" << endl;
    return 1;
  }

  char * dbname = argv[1];
  int seqNumber = atoi(argv[2]);
  Dataset db = dataset_setup_GTDA_v3();
  if(strcmp(dbname, "GTDA_v4"))
    db = dataset_setup_GTDA_v4();

  int startFrame = atoi(argv[3]);
  int endFrame = atoi(argv[4]);
  float resizeFactor = atof(argv[5]);
  db.setScale(resizeFactor);

  //Sequence sq_felz(dataDir, seqName, imType, startFrame, endFrame, FELZ_SEG, resizeFactor);
  Sequence sq_b(db, seqNumber, startFrame, endFrame, BERKELEY_SEG);

  
  /*Mat imst_felz = sq_felz.getPrior(startFrame).getImage();
  Mat imen_felz = sq_felz.getPrior(endFrame).getImage();
  imshow("imst_felz", imst_felz);
  imshow("imen_felz", imen_felz);
  Mat segst_felz = sq_felz.getPrior(startFrame).getSegmentation();
  Mat segen_felz = sq_felz.getPrior(endFrame).getSegmentation();
  showSegmentationRandom(segst_felz, "segst_felz");
  showSegmentationRandom(segen_felz, "segen_felz");*/
  
  Mat imst_b = sq_b.getPrior(startFrame).getImage();
  Mat imen_b = sq_b.getPrior(endFrame).getImage();
  imshow("imst_b", imst_b);
  imshow("imen_b", imen_b);
  Mat segst_b = sq_b.getPrior(startFrame).getSegmentation();
  Mat segen_b = sq_b.getPrior(endFrame).getSegmentation();
  showSegmentationRandom(segst_b, "segst_b");
  showSegmentationRandom(segen_b, "segen_b");

  //Mat fv = sq_b.xiaofengFeatureVector(startFrame+10);
  //cout << "Xiaofeng FV size: " << fv.rows << " " << fv.cols << endl;

  cvWaitKey(0);

  return 0;
}

