#include "SparseStuff.h"

using namespace std;
using namespace cv;

int main(int argc, char **argv) {

  Mat A(4, 4, CV_32F);
  for(int i = 0; i < A.rows; i++)
    for(int j = 0; j < A.cols; j++)
      A.at<float>(i,j) = 0;
  A.at<float>(0,0) = 1;
  A.at<float>(0,1) = 2;
  A.at<float>(1,0) = 2;
  A.at<float>(0,2) = 3;
  A.at<float>(2,0) = 3;
  A.at<float>(2,3) = 2;
  A.at<float>(3,2) = 2;

  SparseMat symA(A);
  SparseMat D = matrixToD<float>(symA);
  Mat temp;
  D.copyTo(temp);
  cout << "D: " << temp << endl;

  SparseMat L = getLaplacianMatrix<float>(symA);
  L.copyTo(temp);
  cout << "L: " << temp << endl;


  SparseMat LN = getNormalizedLaplacianMatrix(symA);
  LN.copyTo(temp);
  cout << "LN: " << temp << endl;

  pair<Mat, Mat> answer = eigs(symA, 4, EIGS_SMALLEST);

  eigs(symA, 2, EIGS_LARGEST);

  normalizedSpectralClustering(symA, 2);

  unnormalizedSpectralClustering(symA, 2);

  return 0;
}

